import { Emitter, Event } from '@theia/core';
import { BaseWidget, Message } from '@theia/core/lib/browser';
import { TreeEditor } from './interfaces';
/**
 * Renders the detail view of the tree editor and binds the selected object's data to a generated form.
 */
export declare class DetailFormWidget extends BaseWidget {
    private readonly modelService;
    private selectedNode;
    private store;
    protected changeEmitter: Emitter<Readonly<any>>;
    constructor(modelService: TreeEditor.ModelService);
    get onChange(): Event<Readonly<any>>;
    private initStore;
    /** Augments the default vanilla styles with theia-specific styling and returns the result. */
    private createStyles;
    setSelection(selectedNode: TreeEditor.Node): void;
    protected renderForms(): void;
    protected renderEmptyForms(): void;
    protected onUpdateRequest(msg: Message): void;
}
