import { TreeNode } from '@theia/core/lib/browser/tree';
export var TreeEditor;
(function (TreeEditor) {
    var RootNode;
    (function (RootNode) {
        function is(node) {
            return !!node;
        }
        RootNode.is = is;
    })(RootNode = TreeEditor.RootNode || (TreeEditor.RootNode = {}));
    var Node;
    (function (Node) {
        function is(node) {
            return TreeNode.is(node) && 'jsonforms' in node && !!node['jsonforms'];
        }
        Node.is = is;
        function hasType(node, type) {
            return is(node) && node.jsonforms.type === type;
        }
        Node.hasType = hasType;
    })(Node = TreeEditor.Node || (TreeEditor.Node = {}));
    TreeEditor.ModelService = Symbol('JsonFormsModelService');
    /**
     * Encapsulates logic to create the tree nodes from the tree's input data.
     */
    TreeEditor.NodeFactory = Symbol('NodeFactory');
    var CommandIconInfo;
    (function (CommandIconInfo) {
        function is(info) {
            return !!info && '_id' in info && 'theia-tree-editor-command-icon-info' === info['_id'];
        }
        CommandIconInfo.is = is;
    })(CommandIconInfo = TreeEditor.CommandIconInfo || (TreeEditor.CommandIconInfo = {}));
})(TreeEditor || (TreeEditor = {}));
//# sourceMappingURL=interfaces.js.map