var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { BaseTreeEditorWidget } from './tree-editor-widget';
export var NavigatableTreeEditorOptions = Symbol('NavigatableTreeEditorOptions');
var NavigatableTreeEditorWidget = /** @class */ (function (_super) {
    __extends(NavigatableTreeEditorWidget, _super);
    function NavigatableTreeEditorWidget(treeWidget, formWidget, workspaceService, logger, widget_id, options) {
        var _this = _super.call(this, treeWidget, formWidget, workspaceService, logger, widget_id) || this;
        _this.treeWidget = treeWidget;
        _this.formWidget = formWidget;
        _this.workspaceService = workspaceService;
        _this.logger = logger;
        _this.widget_id = widget_id;
        _this.options = options;
        return _this;
    }
    Object.defineProperty(NavigatableTreeEditorWidget.prototype, "uri", {
        /** The uri of the editor's resource. */
        get: function () {
            return this.options.uri;
        },
        enumerable: false,
        configurable: true
    });
    NavigatableTreeEditorWidget.prototype.getResourceUri = function () {
        return this.uri;
    };
    NavigatableTreeEditorWidget.prototype.createMoveToUri = function (resourceUri) {
        return this.options.uri && this.options.uri.withPath(resourceUri.path);
    };
    NavigatableTreeEditorWidget.prototype.configureTitle = function (title) {
        title.label = this.options.uri.path.base;
        title.caption = this.options.uri.toString();
        title.closable = true;
    };
    return NavigatableTreeEditorWidget;
}(BaseTreeEditorWidget));
export { NavigatableTreeEditorWidget };
//# sourceMappingURL=navigatable-tree-editor-widget.js.map