var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { postConstruct } from 'inversify';
import { TreeEditor } from '../interfaces';
import { NavigatableTreeEditorWidget } from '../navigatable-tree-editor-widget';
var ResourceTreeEditorWidget = /** @class */ (function (_super) {
    __extends(ResourceTreeEditorWidget, _super);
    function ResourceTreeEditorWidget(treeWidget, formWidget, workspaceService, logger, widget_id, options, provider, nodeFactory) {
        var _this = _super.call(this, treeWidget, formWidget, workspaceService, logger, widget_id, options) || this;
        _this.treeWidget = treeWidget;
        _this.formWidget = formWidget;
        _this.workspaceService = workspaceService;
        _this.logger = logger;
        _this.widget_id = widget_id;
        _this.options = options;
        _this.provider = provider;
        _this.nodeFactory = nodeFactory;
        return _this;
    }
    ResourceTreeEditorWidget.prototype.init = function () {
        var _this = this;
        _super.prototype.init.call(this);
        var uri = this.options.uri;
        this.provider.get(uri).then(function (resource) {
            _this.resource = resource;
            _this.load();
        }, function (_) { return console.error("Could not create ressource for uri " + uri); });
    };
    ResourceTreeEditorWidget.prototype.save = function () {
        var _this = this;
        var content = JSON.stringify(this.data);
        this.resource.saveContents(content).then(function (_) { return _this.setDirty(false); }, function (error) { return console.error("Ressource " + _this.uri + " could not be saved.", error); });
    };
    ResourceTreeEditorWidget.prototype.load = function () {
        return __awaiter(this, void 0, void 0, function () {
            var content, error, e_1, json, treeData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        content = undefined;
                        error = false;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.resource.readContents()];
                    case 2:
                        content = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        console.error("Loading " + this.resource.uri + " failed.", e_1);
                        error = true;
                        return [3 /*break*/, 4];
                    case 4:
                        json = JSON.parse(content);
                        this.data = json;
                        treeData = {
                            error: error,
                            data: json
                        };
                        this.treeWidget.setData(treeData);
                        return [2 /*return*/];
                }
            });
        });
    };
    ResourceTreeEditorWidget.prototype.deleteNode = function (node) {
        if (node.parent && TreeEditor.Node.is(node.parent)) {
            var propertyData = node.parent.jsonforms.data[node.jsonforms.property];
            if (Array.isArray(propertyData)) {
                propertyData.splice(Number(node.jsonforms.index), 1);
                // eslint-disable-next-line no-null/no-null
            }
            else if (propertyData !== null && typeof propertyData === 'object') {
                propertyData[node.jsonforms.index] = undefined;
            }
            else {
                this.logger.error("Could not delete node's data from its parent's property " + node.jsonforms.property + ". Property data:", propertyData);
                return;
            }
            // Data was changed in place but need to trigger tree updates.
            this.treeWidget.updateDataForSubtree(node.parent, node.parent.jsonforms.data);
            this.setDirty(true);
        }
    };
    ResourceTreeEditorWidget.prototype.addNode = function (_a) {
        var node = _a.node, type = _a.type, property = _a.property;
        // Create an empty object that only contains its type identifier
        var newData = {};
        newData[this.getTypeProperty()] = type;
        // TODO handle children not being stored in an array
        if (!node.jsonforms.data[property]) {
            node.jsonforms.data[property] = [];
        }
        node.jsonforms.data[property].push(newData);
        this.treeWidget.updateDataForSubtree(node, node.jsonforms.data);
        this.setDirty(true);
    };
    ResourceTreeEditorWidget.prototype.handleFormUpdate = function (data, node) {
        this.treeWidget.updateDataForSubtree(node, data);
        this.setDirty(true);
    };
    __decorate([
        postConstruct(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], ResourceTreeEditorWidget.prototype, "init", null);
    return ResourceTreeEditorWidget;
}(NavigatableTreeEditorWidget));
export { ResourceTreeEditorWidget };
//# sourceMappingURL=resource-tree-editor-widget.js.map